#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Character.h"
#include "TargetWalker.generated.h"

/*
 * A simple ACharacter subclass which will use its default attached AAIController to walk to the target AActor.
 */
UCLASS()
class MMACV2_2023_API ATargetWalker : public ACharacter
{
	GENERATED_BODY()

public:
	// Sets default values for this character's properties. In our case this just means setting the skeletal mesh of
	// our character.
	ATargetWalker();

protected:
	// Called when the game starts or when spawned. This class send the character to the target using its attached
	// AI controller upon game start.
	virtual void BeginPlay() override;

public:	
	// Called every frame, does nothing in this class
	virtual void Tick(float DeltaTime) override;

	// Called to bind functionality to input
	virtual void SetupPlayerInputComponent(class UInputComponent* PlayerInputComponent) override;

	// Where this character will try walking when the game starts. Remember that there has to be a navigation mesh path
	// to our target in the level.
	UPROPERTY(EditAnywhere, Category="Walker")
	TObjectPtr<AActor> Target;

};
